﻿#include <iostream>
#include "commander.h"

int main(int, char **)
{
    auto mainCMD = commander::Command("ai");
    mainCMD.description("AIbox");
    mainCMD.option("config").shortcut("c").description("config file").required(true);
    mainCMD.option("help").description("print help");
    mainCMD.argument("input").description("input file").required(true);
    mainCMD.execute([](const commander::CommandArgument &arg)
                    {
                        std::cout<<"int_opt: "<<arg.option<int32_t>("config")<<std::endl;
                        std::cout<<"float_opt: "<<arg.option<float>("config")<<std::endl;
                        std::cout<<"string_opt: "<<arg.option<std::string>("config")<<std::endl;
                        std::cout<<"bool_opt: "<<arg.option<bool>("config")<<std::endl;
                        std::cout<<"int_arg: "<<arg.argument<int32_t>("input")<<std::endl;
                        std::cout<<"int_arg: "<<arg.argument<int64_t>("input")<<std::endl;
                        std::cout<<"float_arg: "<<arg.argument<float>("input")<<std::endl;
                        std::cout<<"string_arg: "<<arg.argument<std::string>("input")<<std::endl;
                        std::cout<<"bool_arg: "<<arg.argument<bool>("input")<<std::endl;
                        std::cout << "mainCMD"<<std::endl;
                        return 0; });

    commander::Command &subCommand = mainCMD.command("facedet").description("face det");
    char *args[] = {
        "-c",
        "34",
        "3445454545454.5",
    };

    return commander::parse(mainCMD, sizeof(args) / sizeof(args[0]), args);
}
